# coding: utf-8

"""
AuthRolesApi.py
Copyright 2016 SmartBear Software

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
"""

from __future__ import absolute_import

import sys
import os
import re

# python 2 and python 3 compatibility library
from six import iteritems

from ..configuration import Configuration
from ..api_client import ApiClient


class AuthRolesApi(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        config = Configuration()
        if api_client:
            self.api_client = api_client
        else:
            if not config.api_client:
                config.api_client = ApiClient()
            self.api_client = config.api_client

    def create_role_member(self, role_member, role, **kwargs):
        """
        
        Add a member to the role.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.create_role_member(role_member, role, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param AuthAccessAccessItemFileGroup role_member:  (required)
        :param str role:  (required)
        :return: CreateResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['role_member', 'role']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_role_member" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'role_member' is set
        if ('role_member' not in params) or (params['role_member'] is None):
            raise ValueError("Missing the required parameter `role_member` when calling `create_role_member`")
        # verify the required parameter 'role' is set
        if ('role' not in params) or (params['role'] is None):
            raise ValueError("Missing the required parameter `role` when calling `create_role_member`")


        resource_path = '/platform/1/auth/roles/{Role}/members'.replace('{format}', 'json')
        path_params = {}
        if 'role' in params:
            path_params['Role'] = params['role']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'role_member' in params:
            body_params = params['role_member']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['basic_auth']

        response = self.api_client.call_api(resource_path, 'POST',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='CreateResponse',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def create_role_privilege(self, role_privilege, role, **kwargs):
        """
        
        Add a privilege to the role.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.create_role_privilege(role_privilege, role, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param AuthIdNtokenPrivilegeItem role_privilege:  (required)
        :param str role:  (required)
        :return: CreateResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['role_privilege', 'role']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_role_privilege" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'role_privilege' is set
        if ('role_privilege' not in params) or (params['role_privilege'] is None):
            raise ValueError("Missing the required parameter `role_privilege` when calling `create_role_privilege`")
        # verify the required parameter 'role' is set
        if ('role' not in params) or (params['role'] is None):
            raise ValueError("Missing the required parameter `role` when calling `create_role_privilege`")


        resource_path = '/platform/1/auth/roles/{Role}/privileges'.replace('{format}', 'json')
        path_params = {}
        if 'role' in params:
            path_params['Role'] = params['role']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'role_privilege' in params:
            body_params = params['role_privilege']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['basic_auth']

        response = self.api_client.call_api(resource_path, 'POST',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='CreateResponse',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def delete_role_member(self, role_member_id, role, **kwargs):
        """
        
        Remove a member from the role.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.delete_role_member(role_member_id, role, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str role_member_id: Remove a member from the role. (required)
        :param str role:  (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['role_member_id', 'role']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_role_member" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'role_member_id' is set
        if ('role_member_id' not in params) or (params['role_member_id'] is None):
            raise ValueError("Missing the required parameter `role_member_id` when calling `delete_role_member`")
        # verify the required parameter 'role' is set
        if ('role' not in params) or (params['role'] is None):
            raise ValueError("Missing the required parameter `role` when calling `delete_role_member`")


        resource_path = '/platform/1/auth/roles/{Role}/members/{RoleMemberId}'.replace('{format}', 'json')
        path_params = {}
        if 'role_member_id' in params:
            path_params['RoleMemberId'] = params['role_member_id']
        if 'role' in params:
            path_params['Role'] = params['role']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['basic_auth']

        response = self.api_client.call_api(resource_path, 'DELETE',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type=None,
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def delete_role_privilege(self, role_privilege_id, role, **kwargs):
        """
        
        Remove a privilege from a role.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.delete_role_privilege(role_privilege_id, role, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str role_privilege_id: Remove a privilege from a role. (required)
        :param str role:  (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['role_privilege_id', 'role']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_role_privilege" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'role_privilege_id' is set
        if ('role_privilege_id' not in params) or (params['role_privilege_id'] is None):
            raise ValueError("Missing the required parameter `role_privilege_id` when calling `delete_role_privilege`")
        # verify the required parameter 'role' is set
        if ('role' not in params) or (params['role'] is None):
            raise ValueError("Missing the required parameter `role` when calling `delete_role_privilege`")


        resource_path = '/platform/1/auth/roles/{Role}/privileges/{RolePrivilegeId}'.replace('{format}', 'json')
        path_params = {}
        if 'role_privilege_id' in params:
            path_params['RolePrivilegeId'] = params['role_privilege_id']
        if 'role' in params:
            path_params['Role'] = params['role']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['basic_auth']

        response = self.api_client.call_api(resource_path, 'DELETE',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type=None,
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def list_role_members(self, role, **kwargs):
        """
        
        List all the members of the role.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.list_role_members(role, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str role:  (required)
        :param bool resolve_names: Resolve names of personas.
        :return: GroupMembers
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['role', 'resolve_names']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_role_members" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'role' is set
        if ('role' not in params) or (params['role'] is None):
            raise ValueError("Missing the required parameter `role` when calling `list_role_members`")


        resource_path = '/platform/1/auth/roles/{Role}/members'.replace('{format}', 'json')
        path_params = {}
        if 'role' in params:
            path_params['Role'] = params['role']

        query_params = {}
        if 'resolve_names' in params:
            query_params['resolve_names'] = params['resolve_names']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['basic_auth']

        response = self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='GroupMembers',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def list_role_privileges(self, role, **kwargs):
        """
        
        List all privileges in the role.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.list_role_privileges(role, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str role:  (required)
        :return: RolePrivileges
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['role']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_role_privileges" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'role' is set
        if ('role' not in params) or (params['role'] is None):
            raise ValueError("Missing the required parameter `role` when calling `list_role_privileges`")


        resource_path = '/platform/1/auth/roles/{Role}/privileges'.replace('{format}', 'json')
        path_params = {}
        if 'role' in params:
            path_params['Role'] = params['role']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['basic_auth']

        response = self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='RolePrivileges',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response
