# coding: utf-8

"""
ZonesSummaryApi.py
Copyright 2016 SmartBear Software

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
"""

from __future__ import absolute_import

import sys
import os
import re

# python 2 and python 3 compatibility library
from six import iteritems

from ..configuration import Configuration
from ..api_client import ApiClient


class ZonesSummaryApi(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        config = Configuration()
        if api_client:
            self.api_client = api_client
        else:
            if not config.api_client:
                config.api_client = ApiClient()
            self.api_client = config.api_client

    def get_zones_summary(self, **kwargs):
        """
        
        Retrieve access zone summary information.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_zones_summary(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str groupnet: Name of groupnet in which to list zones.
        :return: ZonesSummaryExtended
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['groupnet']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_zones_summary" % key
                )
            params[key] = val
        del params['kwargs']



        resource_path = '/platform/1/zones-summary'.replace('{format}', 'json')
        path_params = {}

        query_params = {}
        if 'groupnet' in params:
            query_params['groupnet'] = params['groupnet']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['basic_auth']

        response = self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='ZonesSummaryExtended',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def get_zones_summary_zone(self, zones_summary_zone, **kwargs):
        """
        
        Retrieve non-privileged access zone information.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_zones_summary_zone(zones_summary_zone, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param int zones_summary_zone: Retrieve non-privileged access zone information. (required)
        :return: ZonesSummary
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['zones_summary_zone']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_zones_summary_zone" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'zones_summary_zone' is set
        if ('zones_summary_zone' not in params) or (params['zones_summary_zone'] is None):
            raise ValueError("Missing the required parameter `zones_summary_zone` when calling `get_zones_summary_zone`")


        resource_path = '/platform/1/zones-summary/{ZonesSummaryZone}'.replace('{format}', 'json')
        path_params = {}
        if 'zones_summary_zone' in params:
            path_params['ZonesSummaryZone'] = params['zones_summary_zone']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['basic_auth']

        response = self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='ZonesSummary',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response
