# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class ClusterConfigOnefsVersion(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        ClusterConfigOnefsVersion - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'build': 'str',
            'copyright': 'str',
            'reldate': 'int',
            'release': 'str',
            'revision': 'str',
            'type': 'str',
            'version': 'str'
        }

        self.attribute_map = {
            'build': 'build',
            'copyright': 'copyright',
            'reldate': 'reldate',
            'release': 'release',
            'revision': 'revision',
            'type': 'type',
            'version': 'version'
        }

        self._build = None
        self._copyright = None
        self._reldate = None
        self._release = None
        self._revision = None
        self._type = None
        self._version = None

    @property
    def build(self):
        """
        Gets the build of this ClusterConfigOnefsVersion.
        OneFS build string.

        :return: The build of this ClusterConfigOnefsVersion.
        :rtype: str
        """
        return self._build

    @build.setter
    def build(self, build):
        """
        Sets the build of this ClusterConfigOnefsVersion.
        OneFS build string.

        :param build: The build of this ClusterConfigOnefsVersion.
        :type: str
        """
        
        self._build = build

    @property
    def copyright(self):
        """
        Gets the copyright of this ClusterConfigOnefsVersion.
        Cluster copyright information.

        :return: The copyright of this ClusterConfigOnefsVersion.
        :rtype: str
        """
        return self._copyright

    @copyright.setter
    def copyright(self, copyright):
        """
        Sets the copyright of this ClusterConfigOnefsVersion.
        Cluster copyright information.

        :param copyright: The copyright of this ClusterConfigOnefsVersion.
        :type: str
        """
        
        self._copyright = copyright

    @property
    def reldate(self):
        """
        Gets the reldate of this ClusterConfigOnefsVersion.
        Timestamp of release date.

        :return: The reldate of this ClusterConfigOnefsVersion.
        :rtype: int
        """
        return self._reldate

    @reldate.setter
    def reldate(self, reldate):
        """
        Sets the reldate of this ClusterConfigOnefsVersion.
        Timestamp of release date.

        :param reldate: The reldate of this ClusterConfigOnefsVersion.
        :type: int
        """
        
        self._reldate = reldate

    @property
    def release(self):
        """
        Gets the release of this ClusterConfigOnefsVersion.
        Kernel release number.

        :return: The release of this ClusterConfigOnefsVersion.
        :rtype: str
        """
        return self._release

    @release.setter
    def release(self, release):
        """
        Sets the release of this ClusterConfigOnefsVersion.
        Kernel release number.

        :param release: The release of this ClusterConfigOnefsVersion.
        :type: str
        """
        
        self._release = release

    @property
    def revision(self):
        """
        Gets the revision of this ClusterConfigOnefsVersion.
        OneFS build number.

        :return: The revision of this ClusterConfigOnefsVersion.
        :rtype: str
        """
        return self._revision

    @revision.setter
    def revision(self, revision):
        """
        Sets the revision of this ClusterConfigOnefsVersion.
        OneFS build number.

        :param revision: The revision of this ClusterConfigOnefsVersion.
        :type: str
        """
        
        self._revision = revision

    @property
    def type(self):
        """
        Gets the type of this ClusterConfigOnefsVersion.
        Kernel release type.

        :return: The type of this ClusterConfigOnefsVersion.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Sets the type of this ClusterConfigOnefsVersion.
        Kernel release type.

        :param type: The type of this ClusterConfigOnefsVersion.
        :type: str
        """
        
        self._type = type

    @property
    def version(self):
        """
        Gets the version of this ClusterConfigOnefsVersion.
        Kernel full version information.

        :return: The version of this ClusterConfigOnefsVersion.
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """
        Sets the version of this ClusterConfigOnefsVersion.
        Kernel full version information.

        :param version: The version of this ClusterConfigOnefsVersion.
        :type: str
        """
        
        self._version = version

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

