# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class ClusterConfigTimezone(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        ClusterConfigTimezone - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'abbreviation': 'str',
            'custom': 'str',
            'name': 'str',
            'path': 'str'
        }

        self.attribute_map = {
            'abbreviation': 'abbreviation',
            'custom': 'custom',
            'name': 'name',
            'path': 'path'
        }

        self._abbreviation = None
        self._custom = None
        self._name = None
        self._path = None

    @property
    def abbreviation(self):
        """
        Gets the abbreviation of this ClusterConfigTimezone.
        Timezone abbreviation.

        :return: The abbreviation of this ClusterConfigTimezone.
        :rtype: str
        """
        return self._abbreviation

    @abbreviation.setter
    def abbreviation(self, abbreviation):
        """
        Sets the abbreviation of this ClusterConfigTimezone.
        Timezone abbreviation.

        :param abbreviation: The abbreviation of this ClusterConfigTimezone.
        :type: str
        """
        
        self._abbreviation = abbreviation

    @property
    def custom(self):
        """
        Gets the custom of this ClusterConfigTimezone.
        Customer timezone information.

        :return: The custom of this ClusterConfigTimezone.
        :rtype: str
        """
        return self._custom

    @custom.setter
    def custom(self, custom):
        """
        Sets the custom of this ClusterConfigTimezone.
        Customer timezone information.

        :param custom: The custom of this ClusterConfigTimezone.
        :type: str
        """
        
        self._custom = custom

    @property
    def name(self):
        """
        Gets the name of this ClusterConfigTimezone.
        Timezone full name.

        :return: The name of this ClusterConfigTimezone.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this ClusterConfigTimezone.
        Timezone full name.

        :param name: The name of this ClusterConfigTimezone.
        :type: str
        """
        
        self._name = name

    @property
    def path(self):
        """
        Gets the path of this ClusterConfigTimezone.
        Timezone hierarchical name.

        :return: The path of this ClusterConfigTimezone.
        :rtype: str
        """
        return self._path

    @path.setter
    def path(self, path):
        """
        Sets the path of this ClusterConfigTimezone.
        Timezone hierarchical name.

        :param path: The path of this ClusterConfigTimezone.
        :type: str
        """
        
        self._path = path

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

