# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class CompatibilitiesClassAvailableAvailableItem(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        CompatibilitiesClassAvailableAvailableItem - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'class_1': 'str',
            'class_2': 'str'
        }

        self.attribute_map = {
            'class_1': 'class_1',
            'class_2': 'class_2'
        }

        self._class_1 = None
        self._class_2 = None

    @property
    def class_1(self):
        """
        Gets the class_1 of this CompatibilitiesClassAvailableAvailableItem.
        The first class in an available compatibility

        :return: The class_1 of this CompatibilitiesClassAvailableAvailableItem.
        :rtype: str
        """
        return self._class_1

    @class_1.setter
    def class_1(self, class_1):
        """
        Sets the class_1 of this CompatibilitiesClassAvailableAvailableItem.
        The first class in an available compatibility

        :param class_1: The class_1 of this CompatibilitiesClassAvailableAvailableItem.
        :type: str
        """
        
        self._class_1 = class_1

    @property
    def class_2(self):
        """
        Gets the class_2 of this CompatibilitiesClassAvailableAvailableItem.
        The second class in an available compatibility

        :return: The class_2 of this CompatibilitiesClassAvailableAvailableItem.
        :rtype: str
        """
        return self._class_2

    @class_2.setter
    def class_2(self, class_2):
        """
        Sets the class_2 of this CompatibilitiesClassAvailableAvailableItem.
        The second class in an available compatibility

        :param class_2: The class_2 of this CompatibilitiesClassAvailableAvailableItem.
        :type: str
        """
        
        self._class_2 = class_2

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

