# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class DiagnosticsGatherStatus(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        DiagnosticsGatherStatus - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'active_status': 'str',
            'last_status': 'str'
        }

        self.attribute_map = {
            'active_status': 'Active_Status',
            'last_status': 'Last_Status'
        }

        self._active_status = None
        self._last_status = None

    @property
    def active_status(self):
        """
        Gets the active_status of this DiagnosticsGatherStatus.
        The current status of the process

        :return: The active_status of this DiagnosticsGatherStatus.
        :rtype: str
        """
        return self._active_status

    @active_status.setter
    def active_status(self, active_status):
        """
        Sets the active_status of this DiagnosticsGatherStatus.
        The current status of the process

        :param active_status: The active_status of this DiagnosticsGatherStatus.
        :type: str
        """
        allowed_values = ["NOT_RUNNING", "RUNNING", "FINISHED", "STOPPING", "STOPPED"]
        if active_status is not None and active_status not in allowed_values:
            raise ValueError(
                "Invalid value for `active_status`, must be one of {0}"
                .format(allowed_values)
            )

        self._active_status = active_status

    @property
    def last_status(self):
        """
        Gets the last_status of this DiagnosticsGatherStatus.
        The previous status of the process

        :return: The last_status of this DiagnosticsGatherStatus.
        :rtype: str
        """
        return self._last_status

    @last_status.setter
    def last_status(self, last_status):
        """
        Sets the last_status of this DiagnosticsGatherStatus.
        The previous status of the process

        :param last_status: The last_status of this DiagnosticsGatherStatus.
        :type: str
        """
        allowed_values = ["NOT_RUNNING", "RUNNING", "FINISHED", "STOPPING", "STOPPED"]
        if last_status is not None and last_status not in allowed_values:
            raise ValueError(
                "Invalid value for `last_status`, must be one of {0}"
                .format(allowed_values)
            )

        self._last_status = last_status

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

