# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class NodePartitionsNode(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        NodePartitionsNode - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'count': 'int',
            'id': 'int',
            'lnn': 'int',
            'partitions': 'list[NodePartitionsNodePartition]'
        }

        self.attribute_map = {
            'count': 'count',
            'id': 'id',
            'lnn': 'lnn',
            'partitions': 'partitions'
        }

        self._count = None
        self._id = None
        self._lnn = None
        self._partitions = None

    @property
    def count(self):
        """
        Gets the count of this NodePartitionsNode.
        Count of how many partitions are included.

        :return: The count of this NodePartitionsNode.
        :rtype: int
        """
        return self._count

    @count.setter
    def count(self, count):
        """
        Sets the count of this NodePartitionsNode.
        Count of how many partitions are included.

        :param count: The count of this NodePartitionsNode.
        :type: int
        """
        
        self._count = count

    @property
    def id(self):
        """
        Gets the id of this NodePartitionsNode.
        Node ID (Device Number) of this node.

        :return: The id of this NodePartitionsNode.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this NodePartitionsNode.
        Node ID (Device Number) of this node.

        :param id: The id of this NodePartitionsNode.
        :type: int
        """
        
        self._id = id

    @property
    def lnn(self):
        """
        Gets the lnn of this NodePartitionsNode.
        Logical Node Number (LNN) of this node.

        :return: The lnn of this NodePartitionsNode.
        :rtype: int
        """
        return self._lnn

    @lnn.setter
    def lnn(self, lnn):
        """
        Sets the lnn of this NodePartitionsNode.
        Logical Node Number (LNN) of this node.

        :param lnn: The lnn of this NodePartitionsNode.
        :type: int
        """
        
        self._lnn = lnn

    @property
    def partitions(self):
        """
        Gets the partitions of this NodePartitionsNode.
        Partition information.

        :return: The partitions of this NodePartitionsNode.
        :rtype: list[NodePartitionsNodePartition]
        """
        return self._partitions

    @partitions.setter
    def partitions(self, partitions):
        """
        Sets the partitions of this NodePartitionsNode.
        Partition information.

        :param partitions: The partitions of this NodePartitionsNode.
        :type: list[NodePartitionsNodePartition]
        """
        
        self._partitions = partitions

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

