# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class PoolsPoolRule(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        PoolsPoolRule - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'description': 'str',
            'iface': 'str',
            'name': 'str',
            'node_type': 'str'
        }

        self.attribute_map = {
            'description': 'description',
            'iface': 'iface',
            'name': 'name',
            'node_type': 'node_type'
        }

        self._description = None
        self._iface = None
        self._name = None
        self._node_type = None

    @property
    def description(self):
        """
        Gets the description of this PoolsPoolRule.
        Description for the provisioning rule.

        :return: The description of this PoolsPoolRule.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this PoolsPoolRule.
        Description for the provisioning rule.

        :param description: The description of this PoolsPoolRule.
        :type: str
        """
        
        if description is not None and len(description) > 128: 
            raise ValueError("Invalid value for `description`, length must be less than `128`")

        self._description = description

    @property
    def iface(self):
        """
        Gets the iface of this PoolsPoolRule.
        Interface name the provisioning rule applies to.

        :return: The iface of this PoolsPoolRule.
        :rtype: str
        """
        return self._iface

    @iface.setter
    def iface(self, iface):
        """
        Sets the iface of this PoolsPoolRule.
        Interface name the provisioning rule applies to.

        :param iface: The iface of this PoolsPoolRule.
        :type: str
        """
        
        self._iface = iface

    @property
    def name(self):
        """
        Gets the name of this PoolsPoolRule.
        Name of the provisioning rule.

        :return: The name of this PoolsPoolRule.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this PoolsPoolRule.
        Name of the provisioning rule.

        :param name: The name of this PoolsPoolRule.
        :type: str
        """
        
        if name is not None and len(name) > 32: 
            raise ValueError("Invalid value for `name`, length must be less than `32`")

        self._name = name

    @property
    def node_type(self):
        """
        Gets the node_type of this PoolsPoolRule.
        Node type the provisioning rule applies to.

        :return: The node_type of this PoolsPoolRule.
        :rtype: str
        """
        return self._node_type

    @node_type.setter
    def node_type(self, node_type):
        """
        Sets the node_type of this PoolsPoolRule.
        Node type the provisioning rule applies to.

        :param node_type: The node_type of this PoolsPoolRule.
        :type: str
        """
        allowed_values = ["any", "storage", "accelerator", "storage-i", "accelerator-i", "backup-accelerator"]
        if node_type is not None and node_type not in allowed_values:
            raise ValueError(
                "Invalid value for `node_type`, must be one of {0}"
                .format(allowed_values)
            )

        self._node_type = node_type

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

