# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class SettingsKrb5DefaultsKrb5Settings(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        SettingsKrb5DefaultsKrb5Settings - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'allow_weak_crypto': 'bool',
            'always_send_preauth': 'bool',
            'default_realm': 'str',
            'dns_lookup_kdc': 'bool',
            'dns_lookup_realm': 'bool'
        }

        self.attribute_map = {
            'allow_weak_crypto': 'allow_weak_crypto',
            'always_send_preauth': 'always_send_preauth',
            'default_realm': 'default_realm',
            'dns_lookup_kdc': 'dns_lookup_kdc',
            'dns_lookup_realm': 'dns_lookup_realm'
        }

        self._allow_weak_crypto = None
        self._always_send_preauth = None
        self._default_realm = None
        self._dns_lookup_kdc = None
        self._dns_lookup_realm = None

    @property
    def allow_weak_crypto(self):
        """
        Gets the allow_weak_crypto of this SettingsKrb5DefaultsKrb5Settings.
        If true, allow the use of DES encryption

        :return: The allow_weak_crypto of this SettingsKrb5DefaultsKrb5Settings.
        :rtype: bool
        """
        return self._allow_weak_crypto

    @allow_weak_crypto.setter
    def allow_weak_crypto(self, allow_weak_crypto):
        """
        Sets the allow_weak_crypto of this SettingsKrb5DefaultsKrb5Settings.
        If true, allow the use of DES encryption

        :param allow_weak_crypto: The allow_weak_crypto of this SettingsKrb5DefaultsKrb5Settings.
        :type: bool
        """
        
        self._allow_weak_crypto = allow_weak_crypto

    @property
    def always_send_preauth(self):
        """
        Gets the always_send_preauth of this SettingsKrb5DefaultsKrb5Settings.
        If true, always attempts to preauthenticate to the domain controller.

        :return: The always_send_preauth of this SettingsKrb5DefaultsKrb5Settings.
        :rtype: bool
        """
        return self._always_send_preauth

    @always_send_preauth.setter
    def always_send_preauth(self, always_send_preauth):
        """
        Sets the always_send_preauth of this SettingsKrb5DefaultsKrb5Settings.
        If true, always attempts to preauthenticate to the domain controller.

        :param always_send_preauth: The always_send_preauth of this SettingsKrb5DefaultsKrb5Settings.
        :type: bool
        """
        
        self._always_send_preauth = always_send_preauth

    @property
    def default_realm(self):
        """
        Gets the default_realm of this SettingsKrb5DefaultsKrb5Settings.
        Specifies the realm for unqualified names.

        :return: The default_realm of this SettingsKrb5DefaultsKrb5Settings.
        :rtype: str
        """
        return self._default_realm

    @default_realm.setter
    def default_realm(self, default_realm):
        """
        Sets the default_realm of this SettingsKrb5DefaultsKrb5Settings.
        Specifies the realm for unqualified names.

        :param default_realm: The default_realm of this SettingsKrb5DefaultsKrb5Settings.
        :type: str
        """
        
        self._default_realm = default_realm

    @property
    def dns_lookup_kdc(self):
        """
        Gets the dns_lookup_kdc of this SettingsKrb5DefaultsKrb5Settings.
        If true, find KDCs through the DNS.

        :return: The dns_lookup_kdc of this SettingsKrb5DefaultsKrb5Settings.
        :rtype: bool
        """
        return self._dns_lookup_kdc

    @dns_lookup_kdc.setter
    def dns_lookup_kdc(self, dns_lookup_kdc):
        """
        Sets the dns_lookup_kdc of this SettingsKrb5DefaultsKrb5Settings.
        If true, find KDCs through the DNS.

        :param dns_lookup_kdc: The dns_lookup_kdc of this SettingsKrb5DefaultsKrb5Settings.
        :type: bool
        """
        
        self._dns_lookup_kdc = dns_lookup_kdc

    @property
    def dns_lookup_realm(self):
        """
        Gets the dns_lookup_realm of this SettingsKrb5DefaultsKrb5Settings.
        If true, find realm names through the DNS.

        :return: The dns_lookup_realm of this SettingsKrb5DefaultsKrb5Settings.
        :rtype: bool
        """
        return self._dns_lookup_realm

    @dns_lookup_realm.setter
    def dns_lookup_realm(self, dns_lookup_realm):
        """
        Sets the dns_lookup_realm of this SettingsKrb5DefaultsKrb5Settings.
        If true, find realm names through the DNS.

        :param dns_lookup_realm: The dns_lookup_realm of this SettingsKrb5DefaultsKrb5Settings.
        :type: bool
        """
        
        self._dns_lookup_realm = dns_lookup_realm

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

